var NAVTREE =
[
  [ "CppAD: A C++ Algorithmic Differentiation Package", "index.html", [
    [ "Modules", "modules.html", [
      [ "bool_fun.hpp", "group__bool__fun__hpp.html", null ],
      [ "tape_link.hpp", "group__tape__link__hpp.html", null ]
    ] ],
    [ "Class List", "annotated.html", [
      [ "AD< Base >", "classAD.html", null ],
      [ "ADFun< Base >", "classADFun.html", null ],
      [ "ADTape< Base >", "classADTape.html", null ],
      [ "cppad_ipopt_fg_info", "classcppad__ipopt__fg__info.html", null ],
      [ "cppad_ipopt_nlp", "classcppad__ipopt__nlp.html", null ],
      [ "cppad_ipopt_solution", "classcppad__ipopt__solution.html", null ],
      [ "discrete< Base >", "classdiscrete.html", null ],
      [ "CppAD::ErrorHandler", "classCppAD_1_1ErrorHandler.html", null ],
      [ "CppAD::IntegrateLast< Fun, SizeVector, FloatVector, Float >", "classCppAD_1_1IntegrateLast.html", null ],
      [ "CppAD::ok_if_S_same_as_T< S, T >", "structCppAD_1_1ok__if__S__same__as__T.html", null ],
      [ "CppAD::ok_if_S_same_as_T< T, T >", "structCppAD_1_1ok__if__S__same__as__T_3_01T_00_01T_01_4.html", null ],
      [ "optimize_csum_stacks", "structoptimize__csum__stacks.html", null ],
      [ "optimize_csum_variable", "structoptimize__csum__variable.html", null ],
      [ "optimize_old_variable", "structoptimize__old__variable.html", null ],
      [ "player< Base >", "classplayer.html", null ],
      [ "recorder< Base >", "classrecorder.html", null ],
      [ "CppAD::RombergMul< Fun, SizeVector, FloatVector, m >", "classCppAD_1_1RombergMul.html", null ],
      [ "CppAD::RombergMul< Fun, SizeVector, FloatVector, 1 >", "classCppAD_1_1RombergMul_3_01Fun_00_01SizeVector_00_01FloatVector_00_011_01_4.html", null ],
      [ "CppAD::SliceLast< Fun, FloatVector >", "classCppAD_1_1SliceLast.html", null ],
      [ "sparse_pack", "classsparse__pack.html", null ],
      [ "sparse_set", "classsparse__set.html", null ],
      [ "CppAD::TrackElement", "classCppAD_1_1TrackElement.html", null ],
      [ "user_atomic< Base >", "classuser__atomic.html", null ],
      [ "CppAD::VecAD< Base >", "classCppAD_1_1VecAD.html", null ],
      [ "CppAD::VecAD_reference< Base >", "classCppAD_1_1VecAD__reference.html", null ],
      [ "CppAD::vector< Type >", "classCppAD_1_1vector.html", null ],
      [ "CppAD::vectorBool", "classCppAD_1_1vectorBool.html", null ],
      [ "CppAD::vectorBoolElement", "classCppAD_1_1vectorBoolElement.html", null ]
    ] ],
    [ "Class Index", "classes.html", null ],
    [ "Class Members", "functions.html", null ],
    [ "Namespace List", "namespaces.html", [
      [ "CppAD", "namespaceCppAD.html", null ]
    ] ],
    [ "Namespace Members", "namespacemembers.html", null ],
    [ "File List", "files.html", [
      [ "abort_recording.hpp", "abort__recording_8hpp.html", null ],
      [ "abs.hpp", "abs_8hpp.html", null ],
      [ "abs_op.hpp", "abs__op_8hpp.html", null ],
      [ "acos_op.hpp", "acos__op_8hpp.html", null ],
      [ "ad.hpp", "ad_8hpp.html", null ],
      [ "ad_binary.hpp", "ad__binary_8hpp.html", null ],
      [ "ad_copy.hpp", "ad__copy_8hpp.html", null ],
      [ "ad_fun.hpp", "ad__fun_8hpp.html", null ],
      [ "ad_tape.hpp", "ad__tape_8hpp.html", null ],
      [ "ad_valued.hpp", "ad__valued_8hpp.html", null ],
      [ "add.hpp", "add_8hpp.html", null ],
      [ "add_eq.hpp", "add__eq_8hpp.html", null ],
      [ "add_op.hpp", "add__op_8hpp.html", null ],
      [ "arithmetic.hpp", "arithmetic_8hpp.html", null ],
      [ "asin_op.hpp", "asin__op_8hpp.html", null ],
      [ "atan2.hpp", "atan2_8hpp.html", null ],
      [ "atan_op.hpp", "atan__op_8hpp.html", null ],
      [ "base_complex.hpp", "base__complex_8hpp.html", null ],
      [ "bender_quad.hpp", "bender__quad_8hpp.html", null ],
      [ "bool_fun.hpp", "bool__fun_8hpp.html", null ],
      [ "bool_valued.hpp", "bool__valued_8hpp.html", null ],
      [ "cap_taylor.hpp", "cap__taylor_8hpp.html", null ],
      [ "check_numeric_type.hpp", "check__numeric__type_8hpp.html", null ],
      [ "check_simple_vector.hpp", "check__simple__vector_8hpp.html", null ],
      [ "comp_op.hpp", "comp__op_8hpp.html", null ],
      [ "compare.hpp", "compare_8hpp.html", null ],
      [ "compute_assign.hpp", "compute__assign_8hpp.html", null ],
      [ "cond_exp.hpp", "cond__exp_8hpp.html", null ],
      [ "cond_op.hpp", "cond__op_8hpp.html", null ],
      [ "configure.hpp", "configure_8hpp.html", null ],
      [ "convert.hpp", "convert_8hpp.html", null ],
      [ "cos_op.hpp", "cos__op_8hpp.html", null ],
      [ "cosh_op.hpp", "cosh__op_8hpp.html", null ],
      [ "cppad.hpp", "cppad_8hpp.html", null ],
      [ "cppad_assert.hpp", "cppad__assert_8hpp.html", null ],
      [ "cppad_ipopt_nlp.cpp", "cppad__ipopt__nlp_8cpp.html", null ],
      [ "cppad_ipopt_nlp.hpp", "cppad__ipopt__nlp_8hpp.html", null ],
      [ "csum_op.hpp", "csum__op_8hpp.html", null ],
      [ "declare.hpp", "declare_8hpp.html", null ],
      [ "declare_ad.hpp", "declare__ad_8hpp.html", null ],
      [ "default.hpp", "default_8hpp.html", null ],
      [ "define.hpp", "define_8hpp.html", null ],
      [ "dependent.hpp", "dependent_8hpp.html", null ],
      [ "discrete.hpp", "discrete_8hpp.html", null ],
      [ "discrete_op.hpp", "discrete__op_8hpp.html", null ],
      [ "div.hpp", "div_8hpp.html", null ],
      [ "div_eq.hpp", "div__eq_8hpp.html", null ],
      [ "div_op.hpp", "div__op_8hpp.html", null ],
      [ "drivers.hpp", "drivers_8hpp.html", null ],
      [ "elapsed_seconds.hpp", "elapsed__seconds_8hpp.html", null ],
      [ "equal_op_seq.hpp", "equal__op__seq_8hpp.html", null ],
      [ "erf.hpp", "erf_8hpp.html", null ],
      [ "error_handler.hpp", "error__handler_8hpp.html", null ],
      [ "exp_op.hpp", "exp__op_8hpp.html", null ],
      [ "for_jac_sweep.hpp", "for__jac__sweep_8hpp.html", null ],
      [ "for_one.hpp", "for__one_8hpp.html", null ],
      [ "for_sparse_jac.hpp", "for__sparse__jac_8hpp.html", null ],
      [ "for_two.hpp", "for__two_8hpp.html", null ],
      [ "forward.hpp", "forward_8hpp.html", null ],
      [ "forward0sweep.hpp", "forward0sweep_8hpp.html", null ],
      [ "forward_sweep.hpp", "forward__sweep_8hpp.html", null ],
      [ "fun_check.hpp", "fun__check_8hpp.html", null ],
      [ "fun_construct.hpp", "fun__construct_8hpp.html", null ],
      [ "fun_eval.hpp", "fun__eval_8hpp.html", null ],
      [ "fun_record.hpp", "fun__record_8hpp.html", null ],
      [ "hash_code.hpp", "hash__code_8hpp.html", null ],
      [ "hes_fg_map.cpp", "hes__fg__map_8cpp.html", null ],
      [ "hes_fg_map.hpp", "hes__fg__map_8hpp.html", null ],
      [ "hessian.hpp", "hessian_8hpp.html", null ],
      [ "identical.hpp", "identical_8hpp.html", null ],
      [ "independent.hpp", "independent_8hpp.html", null ],
      [ "integer.hpp", "integer_8hpp.html", null ],
      [ "jac_g_map.cpp", "jac__g__map_8cpp.html", null ],
      [ "jac_g_map.hpp", "jac__g__map_8hpp.html", null ],
      [ "jacobian.hpp", "jacobian_8hpp.html", null ],
      [ "load_op.hpp", "load__op_8hpp.html", null ],
      [ "log_op.hpp", "log__op_8hpp.html", null ],
      [ "lu_factor.hpp", "lu__factor_8hpp.html", null ],
      [ "lu_invert.hpp", "lu__invert_8hpp.html", null ],
      [ "lu_ratio.hpp", "lu__ratio_8hpp.html", null ],
      [ "lu_solve.hpp", "lu__solve_8hpp.html", null ],
      [ "math_other.hpp", "math__other_8hpp.html", null ],
      [ "mul.hpp", "mul_8hpp.html", null ],
      [ "mul_eq.hpp", "mul__eq_8hpp.html", null ],
      [ "mul_op.hpp", "mul__op_8hpp.html", null ],
      [ "nan.hpp", "nan_8hpp.html", null ],
      [ "near_equal.hpp", "near__equal_8hpp.html", null ],
      [ "near_equal_ext.hpp", "near__equal__ext_8hpp.html", null ],
      [ "ode_err_control.hpp", "ode__err__control_8hpp.html", null ],
      [ "ode_gear.hpp", "ode__gear_8hpp.html", null ],
      [ "ode_gear_control.hpp", "ode__gear__control_8hpp.html", null ],
      [ "omp_max_thread.hpp", "omp__max__thread_8hpp.html", null ],
      [ "op.hpp", "op_8hpp.html", null ],
      [ "op_code.hpp", "op__code_8hpp.html", null ],
      [ "opt_val_hes.hpp", "opt__val__hes_8hpp.html", null ],
      [ "optimize.hpp", "optimize_8hpp.html", null ],
      [ "ordered.hpp", "ordered_8hpp.html", null ],
      [ "output.hpp", "output_8hpp.html", null ],
      [ "par_var.hpp", "par__var_8hpp.html", null ],
      [ "parameter_op.hpp", "parameter__op_8hpp.html", null ],
      [ "player.hpp", "player_8hpp.html", null ],
      [ "poly.hpp", "poly_8hpp.html", null ],
      [ "pow.hpp", "pow_8hpp.html", null ],
      [ "pow_int.hpp", "pow__int_8hpp.html", null ],
      [ "pow_op.hpp", "pow__op_8hpp.html", null ],
      [ "print_for.hpp", "print__for_8hpp.html", null ],
      [ "print_op.hpp", "print__op_8hpp.html", null ],
      [ "prototype_op.hpp", "prototype__op_8hpp.html", null ],
      [ "recorder.hpp", "recorder_8hpp.html", null ],
      [ "rev_hes_sweep.hpp", "rev__hes__sweep_8hpp.html", null ],
      [ "rev_jac_sweep.hpp", "rev__jac__sweep_8hpp.html", null ],
      [ "rev_one.hpp", "rev__one_8hpp.html", null ],
      [ "rev_sparse_hes.hpp", "rev__sparse__hes_8hpp.html", null ],
      [ "rev_sparse_jac.hpp", "rev__sparse__jac_8hpp.html", null ],
      [ "rev_two.hpp", "rev__two_8hpp.html", null ],
      [ "reverse.hpp", "reverse_8hpp.html", null ],
      [ "reverse_sweep.hpp", "reverse__sweep_8hpp.html", null ],
      [ "romberg_mul.hpp", "romberg__mul_8hpp.html", null ],
      [ "romberg_one.hpp", "romberg__one_8hpp.html", null ],
      [ "rosen_34.hpp", "rosen__34_8hpp.html", null ],
      [ "runge_45.hpp", "runge__45_8hpp.html", null ],
      [ "sin_op.hpp", "sin__op_8hpp.html", null ],
      [ "sinh_op.hpp", "sinh__op_8hpp.html", null ],
      [ "sparse.hpp", "sparse_8hpp.html", null ],
      [ "sparse_binary_op.hpp", "sparse__binary__op_8hpp.html", null ],
      [ "sparse_hessian.hpp", "sparse__hessian_8hpp.html", null ],
      [ "sparse_jacobian.hpp", "sparse__jacobian_8hpp.html", null ],
      [ "sparse_map2vec.cpp", "sparse__map2vec_8cpp.html", null ],
      [ "sparse_map2vec.hpp", "sparse__map2vec_8hpp.html", null ],
      [ "sparse_pack.hpp", "sparse__pack_8hpp.html", null ],
      [ "sparse_set.hpp", "sparse__set_8hpp.html", null ],
      [ "sparse_unary_op.hpp", "sparse__unary__op_8hpp.html", null ],
      [ "speed_test.hpp", "speed__test_8hpp.html", null ],
      [ "sqrt_op.hpp", "sqrt__op_8hpp.html", null ],
      [ "std_math_ad.hpp", "std__math__ad_8hpp.html", null ],
      [ "std_math_unary.hpp", "std__math__unary_8hpp.html", null ],
      [ "store_op.hpp", "store__op_8hpp.html", null ],
      [ "sub.hpp", "sub_8hpp.html", null ],
      [ "sub_eq.hpp", "sub__eq_8hpp.html", null ],
      [ "sub_op.hpp", "sub__op_8hpp.html", null ],
      [ "tape_link.hpp", "tape__link_8hpp.html", null ],
      [ "test_vector.hpp", "test__vector_8hpp.html", null ],
      [ "track_new_del.hpp", "track__new__del_8hpp.html", null ],
      [ "unary_minus.hpp", "unary__minus_8hpp.html", null ],
      [ "unary_plus.hpp", "unary__plus_8hpp.html", null ],
      [ "undef.hpp", "undef_8hpp.html", null ],
      [ "user_ad.hpp", "user__ad_8hpp.html", null ],
      [ "user_atomic.hpp", "user__atomic_8hpp.html", null ],
      [ "value.hpp", "value_8hpp.html", null ],
      [ "var2par.hpp", "var2par_8hpp.html", null ],
      [ "vec_ad.hpp", "vec__ad_8hpp.html", null ],
      [ "vec_fun_pattern.cpp", "vec__fun__pattern_8cpp.html", null ],
      [ "vec_fun_pattern.hpp", "vec__fun__pattern_8hpp.html", null ],
      [ "vector.hpp", "vector_8hpp.html", null ]
    ] ],
    [ "Directories", "dirs.html", [
      [ "cppad", "dir_25d40635a3192d90a482374e5f24ee55.html", [
        [ "local", "dir_879616a309c91e0342e50d3a0b1a1c59.html", null ]
      ] ],
      [ "cppad_ipopt", "dir_be6736fee3b86035b49e66d1bbda8322.html", [
        [ "src", "dir_f88d47053c6461b8278933a6ef403105.html", null ]
      ] ]
    ] ],
    [ "File Members", "globals.html", null ]
  ] ]
];

function createIndent(o,domNode,node,level)
{
  if (node.parentNode && node.parentNode.parentNode)
  {
    createIndent(o,domNode,node.parentNode,level+1);
  }
  var imgNode = document.createElement("img");
  if (level==0 && node.childrenData)
  {
    node.plus_img = imgNode;
    node.expandToggle = document.createElement("a");
    node.expandToggle.href = "javascript:void(0)";
    node.expandToggle.onclick = function() 
    {
      if (node.expanded) 
      {
        $(node.getChildrenUL()).slideUp("fast");
        if (node.isLast)
        {
          node.plus_img.src = node.relpath+"ftv2plastnode.png";
        }
        else
        {
          node.plus_img.src = node.relpath+"ftv2pnode.png";
        }
        node.expanded = false;
      } 
      else 
      {
        expandNode(o, node, false);
      }
    }
    node.expandToggle.appendChild(imgNode);
    domNode.appendChild(node.expandToggle);
  }
  else
  {
    domNode.appendChild(imgNode);
  }
  if (level==0)
  {
    if (node.isLast)
    {
      if (node.childrenData)
      {
        imgNode.src = node.relpath+"ftv2plastnode.png";
      }
      else
      {
        imgNode.src = node.relpath+"ftv2lastnode.png";
        domNode.appendChild(imgNode);
      }
    }
    else
    {
      if (node.childrenData)
      {
        imgNode.src = node.relpath+"ftv2pnode.png";
      }
      else
      {
        imgNode.src = node.relpath+"ftv2node.png";
        domNode.appendChild(imgNode);
      }
    }
  }
  else
  {
    if (node.isLast)
    {
      imgNode.src = node.relpath+"ftv2blank.png";
    }
    else
    {
      imgNode.src = node.relpath+"ftv2vertline.png";
    }
  }
  imgNode.border = "0";
}

function newNode(o, po, text, link, childrenData, lastNode)
{
  var node = new Object();
  node.children = Array();
  node.childrenData = childrenData;
  node.depth = po.depth + 1;
  node.relpath = po.relpath;
  node.isLast = lastNode;

  node.li = document.createElement("li");
  po.getChildrenUL().appendChild(node.li);
  node.parentNode = po;

  node.itemDiv = document.createElement("div");
  node.itemDiv.className = "item";

  node.labelSpan = document.createElement("span");
  node.labelSpan.className = "label";

  createIndent(o,node.itemDiv,node,0);
  node.itemDiv.appendChild(node.labelSpan);
  node.li.appendChild(node.itemDiv);

  var a = document.createElement("a");
  node.labelSpan.appendChild(a);
  node.label = document.createTextNode(text);
  a.appendChild(node.label);
  if (link) 
  {
    a.href = node.relpath+link;
  } 
  else 
  {
    if (childrenData != null) 
    {
      a.className = "nolink";
      a.href = "javascript:void(0)";
      a.onclick = node.expandToggle.onclick;
      node.expanded = false;
    }
  }

  node.childrenUL = null;
  node.getChildrenUL = function() 
  {
    if (!node.childrenUL) 
    {
      node.childrenUL = document.createElement("ul");
      node.childrenUL.className = "children_ul";
      node.childrenUL.style.display = "none";
      node.li.appendChild(node.childrenUL);
    }
    return node.childrenUL;
  };

  return node;
}

function showRoot()
{
  var headerHeight = $("#top").height();
  var footerHeight = $("#nav-path").height();
  var windowHeight = $(window).height() - headerHeight - footerHeight;
  navtree.scrollTo('#selected',0,{offset:-windowHeight/2});
}

function expandNode(o, node, imm)
{
  if (node.childrenData && !node.expanded) 
  {
    if (!node.childrenVisited) 
    {
      getNode(o, node);
    }
    if (imm)
    {
      $(node.getChildrenUL()).show();
    } 
    else 
    {
      $(node.getChildrenUL()).slideDown("fast",showRoot);
    }
    if (node.isLast)
    {
      node.plus_img.src = node.relpath+"ftv2mlastnode.png";
    }
    else
    {
      node.plus_img.src = node.relpath+"ftv2mnode.png";
    }
    node.expanded = true;
  }
}

function getNode(o, po)
{
  po.childrenVisited = true;
  var l = po.childrenData.length-1;
  for (var i in po.childrenData) 
  {
    var nodeData = po.childrenData[i];
    po.children[i] = newNode(o, po, nodeData[0], nodeData[1], nodeData[2],
        i==l);
  }
}

function findNavTreePage(url, data)
{
  var nodes = data;
  var result = null;
  for (var i in nodes) 
  {
    var d = nodes[i];
    if (d[1] == url) 
    {
      return new Array(i);
    }
    else if (d[2] != null) // array of children
    {
      result = findNavTreePage(url, d[2]);
      if (result != null) 
      {
        return (new Array(i).concat(result));
      }
    }
  }
  return null;
}

function initNavTree(toroot,relpath)
{
  var o = new Object();
  o.toroot = toroot;
  o.node = new Object();
  o.node.li = document.getElementById("nav-tree-contents");
  o.node.childrenData = NAVTREE;
  o.node.children = new Array();
  o.node.childrenUL = document.createElement("ul");
  o.node.getChildrenUL = function() { return o.node.childrenUL; };
  o.node.li.appendChild(o.node.childrenUL);
  o.node.depth = 0;
  o.node.relpath = relpath;

  getNode(o, o.node);

  o.breadcrumbs = findNavTreePage(toroot, NAVTREE);
  if (o.breadcrumbs == null)
  {
    o.breadcrumbs = findNavTreePage("index.html",NAVTREE);
  }
  if (o.breadcrumbs != null && o.breadcrumbs.length>0)
  {
    var p = o.node;
    for (var i in o.breadcrumbs) 
    {
      var j = o.breadcrumbs[i];
      p = p.children[j];
      expandNode(o,p,true);
    }
    p.itemDiv.className = p.itemDiv.className + " selected";
    p.itemDiv.id = "selected";
    $(window).load(showRoot);
  }
}

